Index: fs/smbfs/proc.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/smbfs/proc.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/smbfs/proc.c	22 Jul 2004 19:48:52 -0000	1.1
+++ fs/smbfs/proc.c	4 Aug 2004 01:33:36 -0000	1.2
@@ -2600,3 +3088,275 @@
 	smb_unlock_server(server);
 	return result;
 }
+
+int
+smb_proc_read_link(struct smb_sb_info *server, struct dentry *dentry,
+		   char *buffer, int len)
+{
+	char *p, *param = server->temp_buf;
+	unsigned char *resp_data = NULL;
+	unsigned char *resp_param = NULL;
+	int resp_data_len = 0;
+	int resp_param_len = 0;
+	int result;
+
+	DEBUG1("readlink of %s/%s\n", DENTRY_PATH(dentry));
+
+	smb_lock_server(server);
+  retry:
+	WSET(param, 0, SMB_QUERY_FILE_UNIX_LINK);
+	DSET(param, 2, 0);
+	result = smb_encode_path(server, param + 6, SMB_MAXPATHLEN+1, dentry, NULL);
+	if (result < 0)
+		goto out;
+	p = param + 6 + result;
+
+	result = smb_trans2_request(server, TRANSACT2_QPATHINFO,
+				    0, NULL, p - param, param,
+				    &resp_data_len, &resp_data,
+				    &resp_param_len, &resp_param);
+	DEBUG1("for %s: result=%d, rcls=%d, err=%d\n",
+		&param[6], result, server->rcls, server->err);
+	if (result < 0) {
+		if (smb_retry(server))
+			goto retry;
+		goto out;
+	}
+	if (server->rcls != 0) {
+		VERBOSE("for %s: result=%d, rcls=%d, err=%d\n",
+			&param[6], result, server->rcls, server->err);
+		result = smb_errno(server);
+		goto out;
+	}
+
+	/* copy data up to the \0 or buffer length */
+	result = len;
+	if (resp_data_len < len)
+		result = resp_data_len;
+	strncpy(buffer, resp_data, result);
+
+out:
+	smb_unlock_server(server);
+	return result;
+}
+
+
+/*
+ * Create a symlink object called dentry which points to oldpath.
+ * Samba does not permit dangling links but returns a suitable error message.
+ */
+int
+smb_proc_symlink(struct smb_sb_info *server, struct dentry *dentry,
+		 const char *oldpath)
+{
+	char *p, *param = server->temp_buf;
+	unsigned char *resp_data = NULL;
+	unsigned char *resp_param = NULL;
+	int resp_data_len = 0;
+	int resp_param_len = 0;
+	int result;
+
+	smb_lock_server(server);
+  retry:
+	WSET(param, 0, SMB_SET_FILE_UNIX_LINK);
+	DSET(param, 2, 0);
+	result = smb_encode_path(server, param + 6, SMB_MAXPATHLEN+1, dentry, NULL);
+	if (result < 0)
+		goto out;
+	p = param + 6 + result;
+
+	result = smb_trans2_request(server, TRANSACT2_SETPATHINFO,
+				    strlen(oldpath) + 1,
+				    (char *)oldpath, p - param, param,
+				    &resp_data_len, &resp_data,
+				    &resp_param_len, &resp_param);
+	DEBUG1("for %s: result=%d, rcls=%d, err=%d\n",
+		&param[6], result, server->rcls, server->err);
+	if (result < 0) {
+		if (smb_retry(server))
+			goto retry;
+		goto out;
+	}
+	if (server->rcls != 0) {
+		VERBOSE("for %s: result=%d, rcls=%d, err=%d\n",
+			&param[6], result, server->rcls, server->err);
+		result = smb_errno(server);
+		goto out;
+	}
+
+	result = 0;
+
+out:
+	smb_unlock_server(server);
+	return result;
+}
+
+/*
+ * Create a hard link object called new_dentry which points to dentry.
+ */
+int
+smb_proc_link(struct smb_sb_info *server, struct dentry *dentry,
+	      struct dentry *new_dentry)
+{
+	char *p, *param = server->temp_buf;
+	unsigned char *resp_data = NULL;
+	unsigned char *resp_param = NULL;
+	int resp_data_len = 0;
+	int resp_param_len = 0;
+	int result;
+	int newpathlen = 0;
+	char newpath[SMB_MAXPATHLEN+1];		/* FIXME: ugh! */
+
+	smb_lock_server(server);
+
+	newpathlen = smb_encode_path(server, newpath, SMB_MAXPATHLEN+1, dentry, NULL);
+
+	DEBUG1("newpathlen = %d newpath=\"%s\"\n", newpathlen, newpath);
+retry:
+	WSET(param, 0, SMB_SET_FILE_UNIX_HLINK);
+	DSET(param, 2, 0);
+	result = smb_encode_path(server, param + 6, SMB_MAXPATHLEN+1, new_dentry, NULL);
+	if (result < 0)
+		goto out;
+	p = param + 6 + result;
+	DEBUG1("pathlen = %d oldpath=\"%s\"\n", result, param + 6);
+
+
+	result = smb_trans2_request(server, TRANSACT2_SETPATHINFO,
+				    newpathlen + 1,
+				    (char *)newpath, p - param, param,
+				    &resp_data_len, &resp_data,
+				    &resp_param_len, &resp_param);
+	DEBUG1("for %s: result=%d, rcls=%d, err=%d\n",
+               &param[6], result, server->rcls, server->err);
+	if (result < 0) {
+		if (smb_retry(server))
+			goto retry;
+		goto out;
+	}
+	if (server->rcls != 0) {
+		VERBOSE("for %s: result=%d, rcls=%d, err=%d\n",
+			&param[6], result, server->rcls, server->err);
+		result = smb_errno(server);
+		goto out;
+	}
+
+	result = 0;
+
+out:
+	smb_unlock_server(server);
+	return result;
+}
+
+/*
+ * We are called with the server locked
+ */
+static int
+smb_proc_query_cifsunix(struct smb_sb_info *server)
+{
+	char *param = server->temp_buf;
+	unsigned char *resp_data = NULL;
+	unsigned char *resp_param = NULL;
+	int resp_data_len = 0;
+	int resp_param_len = 0;
+	int result;
+	int major, minor;
+	u64 caps;
+
+  retry:
+	WSET(param, 0, SMB_QUERY_CIFS_UNIX_INFO);
+	result = smb_trans2_request(server, TRANSACT2_QFSINFO,
+				    0, NULL, 2, param,
+				    &resp_data_len, &resp_data,
+				    &resp_param_len, &resp_param);
+	if (result < 0) {
+		if (smb_retry(server))
+			goto retry;
+		goto out;
+	}
+
+	if (resp_data_len < 12) {
+		PARANOIA("Not enough data\n");
+		goto out;
+	}
+
+	major = WVAL(resp_data, 0);
+	minor = WVAL(resp_data, 2);
+	VERBOSE("Server implements CIFS Extensions for UNIX systems v%d.%d\n",
+		major, minor);
+	/* FIXME: verify that we are ok with this major/minor? */
+
+	caps = LVAL(resp_data, 4);
+	DEBUG1("Server capabilities 0x%016llx\n", caps);
+
+out:
+	return result;
+}
+
+
+static void
+install_ops(struct smb_ops *dst, struct smb_ops *src)
+{
+	memcpy(dst, src, sizeof(void *) * SMB_OPS_NUM_STATIC);
+}
+
+/* < LANMAN2 */
+static struct smb_ops smb_ops_core =
+{
+	.read           = smb_proc_read,
+	.write          = smb_proc_write,
+	.readdir        = smb_proc_readdir_short,
+	.getattr        = smb_proc_getattr_core,
+	.truncate       = smb_proc_trunc32,
+};
+
+/* LANMAN2, OS/2, others? */
+static struct smb_ops smb_ops_os2 =
+{
+	.read           = smb_proc_read,
+	.write          = smb_proc_write,
+	.readdir        = smb_proc_readdir_long,
+	.getattr        = smb_proc_getattr_trans2_std,
+	.truncate       = smb_proc_trunc32,
+};
+
+/* Win95, and possibly some NetApp versions too */
+static struct smb_ops smb_ops_win95 =
+{
+	.read           = smb_proc_read,    /* does not support 12word readX */
+	.write          = smb_proc_write,
+	.readdir        = smb_proc_readdir_long,
+	.getattr        = smb_proc_getattr_95,
+	.truncate       = smb_proc_trunc95,
+};
+
+/* Samba, NT4 and NT5 */
+static struct smb_ops smb_ops_winNT =
+{
+	.read           = smb_proc_readX,
+	.write          = smb_proc_writeX,
+	.readdir        = smb_proc_readdir_long,
+	.getattr        = smb_proc_getattr_trans2_all,
+	.truncate       = smb_proc_trunc64,
+};
+
+/* Samba w/ unix extensions. Others? */
+static struct smb_ops smb_ops_unix =
+{
+	.read           = smb_proc_readX,
+	.write          = smb_proc_writeX,
+	.readdir        = smb_proc_readdir_long,
+	.getattr        = smb_proc_getattr_unix,
+	.truncate       = smb_proc_trunc64,
+};
+
+/* Place holder until real ops are in place */
+static struct smb_ops smb_ops_null =
+{
+	.getattr        = smb_proc_getattr_null,
+};
+
+void smb_install_null_ops(struct smb_ops *ops)
+{
+	install_ops(ops, &smb_ops_null);
+}
Index: fs/vfat/namei.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/vfat/namei.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/vfat/namei.c	22 Jul 2004 19:48:52 -0000	1.1
+++ fs/vfat/namei.c	4 Aug 2004 01:33:37 -0000	1.2
@@ -408,9 +408,10 @@
 {
 	struct msdos_dir_entry *de;
 	struct buffer_head *bh = NULL;
-	int ino,res;
+	loff_t i_pos;
+	int res;
 
-	res=fat_scan(dir,name,&bh,&de,&ino);
+	res = fat_scan(dir, name, &bh, &de, &i_pos);
 	fat_brelse(dir->i_sb, bh);
 	if (res<0)
 		return -ENOENT;
@@ -891,7 +892,7 @@
 	int res, len;
 	struct msdos_dir_entry *dummy_de;
 	struct buffer_head *dummy_bh;
-	int dummy_ino;
+	loff_t dummy_i_pos;
 	loff_t dummy;
 
 	dir_slots = (struct msdos_dir_slot *)
@@ -917,7 +918,7 @@
 		goto cleanup;
 
 	/* build the empty directory entry of number of slots */
-	offset = fat_add_entries(dir, slots, &dummy_bh, &dummy_de, &dummy_ino);
+	offset = fat_add_entries(dir, slots, &dummy_bh, &dummy_de, &dummy_i_pos);
 	if (offset < 0) {
 		res = offset;
 		goto cleanup;
@@ -927,7 +928,7 @@
 	/* Now create the new entry */
 	*bh = NULL;
 	for (slot = 0; slot < slots; slot++) {
-		if (fat_get_entry(dir, &offset, bh, de, &sinfo_out->ino) < 0) {
+		if (fat_get_entry(dir, &offset, bh, de, &sinfo_out->i_pos) < 0) {
 			res = -EIO;
 			goto cleanup;
 		}
@@ -972,7 +973,7 @@
 			&offset,&sinfo->longname_offset);
 	if (res>0) {
 		sinfo->long_slots = res-1;
-		if (fat_get_entry(dir,&offset,last_bh,last_de,&sinfo->ino)>=0)
+		if (fat_get_entry(dir,&offset,last_bh,last_de,&sinfo->i_pos)>=0)
 			return 0;
 		res = -EIO;
 	} 
@@ -1001,7 +1002,7 @@
 		table++;
 		goto error;
 	}
-	inode = fat_build_inode(dir->i_sb, de, sinfo.ino, &res);
+	inode = fat_build_inode(dir->i_sb, de, sinfo.i_pos, &res);
 	fat_brelse(dir->i_sb, bh);
 	if (res)
 		return ERR_PTR(res);
@@ -1034,7 +1035,7 @@
 	res = vfat_add_entry(dir, &dentry->d_name, 0, &sinfo, &bh, &de);
 	if (res < 0)
 		return res;
-	inode = fat_build_inode(sb, de, sinfo.ino, &res);
+	inode = fat_build_inode(sb, de, sinfo.i_pos, &res);
 	fat_brelse(sb, bh);
 	if (!inode)
 		return res;
@@ -1051,8 +1052,8 @@
      struct buffer_head *bh, struct msdos_dir_entry *de)
 {
 	struct super_block *sb = dir->i_sb;
-	loff_t offset;
-	int i,ino;
+	loff_t offset, i_pos;
+	int i;
 
 	/* remove the shortname */
 	dir->i_mtime = CURRENT_TIME;
@@ -1064,7 +1065,7 @@
 	/* remove the longname */
 	offset = sinfo->longname_offset; de = NULL;
 	for (i = sinfo->long_slots; i > 0; --i) {
-		if (fat_get_entry(dir, &offset, &bh, &de, &ino) < 0)
+		if (fat_get_entry(dir, &offset, &bh, &de, &i_pos) < 0)
 			continue;
 		de->name[0] = DELETED_FLAG;
 		de->attr = 0;
@@ -1133,7 +1134,7 @@
 	res = vfat_add_entry(dir, &dentry->d_name, 1, &sinfo, &bh, &de);
 	if (res < 0)
 		return res;
-	inode = fat_build_inode(sb, de, sinfo.ino, &res);
+	inode = fat_build_inode(sb, de, sinfo.i_pos, &res);
 	if (!inode)
 		goto out;
 	inode->i_mtime = inode->i_atime = inode->i_ctime = CURRENT_TIME;
@@ -1170,7 +1171,7 @@
 	struct super_block *sb = old_dir->i_sb;
 	struct buffer_head *old_bh,*new_bh,*dotdot_bh;
 	struct msdos_dir_entry *old_de,*new_de,*dotdot_de;
-	int dotdot_ino;
+	loff_t dotdot_i_pos;
 	struct inode *old_inode, *new_inode;
 	int res, is_dir;
 	struct vfat_slot_info old_sinfo,sinfo;
@@ -1185,13 +1186,13 @@
 	is_dir = S_ISDIR(old_inode->i_mode);
 
 	if (is_dir && (res = fat_scan(old_inode,MSDOS_DOTDOT,&dotdot_bh,
-				&dotdot_de,&dotdot_ino)) < 0)
+				&dotdot_de,&dotdot_i_pos)) < 0)
 		goto rename_done;
 
 	if (new_dentry->d_inode) {
 		res = vfat_find(new_dir,&new_dentry->d_name,&sinfo,&new_bh,
 				&new_de);
-		if (res < 0 || MSDOS_I(new_inode)->i_location != sinfo.ino) {
+		if (res < 0 || MSDOS_I(new_inode)->i_pos != sinfo.i_pos) {
 			/* WTF??? Cry and fail. */
 			printk(KERN_WARNING "vfat_rename: fs corrupted\n");
 			goto rename_done;
@@ -1215,7 +1216,7 @@
 	vfat_remove_entry(old_dir,&old_sinfo,old_bh,old_de);
 	old_bh=NULL;
 	fat_detach(old_inode);
-	fat_attach(old_inode, sinfo.ino);
+	fat_attach(old_inode, sinfo.i_pos);
 	mark_inode_dirty(old_inode);
 
 	old_dir->i_version = ++event;
Index: fs/yaffs/yaffs_fs.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/yaffs/yaffs_fs.c,v
retrieving revision 1.1
retrieving revision 1.4
diff -u -r1.1 -r1.4
--- fs/yaffs/yaffs_fs.c	16 Nov 2004 17:16:24 -0000	1.1
+++ fs/yaffs/yaffs_fs.c	14 Feb 2006 18:20:02 -0000	1.4
@@ -29,7 +29,7 @@
  */
 
 
-const char *yaffs_fs_c_version = "$Id: yaffs_fs.c,v 1.1 2004/11/16 17:16:24 joff Exp $";
+const char *yaffs_fs_c_version = "$Id: yaffs_fs.c,v 1.4 2006/02/14 18:20:02 michael Exp $";
 extern const char *yaffs_guts_c_version;
 
 
@@ -72,7 +72,7 @@
 
 
 
-unsigned yaffs_traceMask = YAFFS_TRACE_ALWAYS | YAFFS_TRACE_BAD_BLOCKS;
+unsigned yaffs_traceMask = 0; // YAFFS_TRACE_ALWAYS | YAFFS_TRACE_BAD_BLOCKS;
 
 #ifdef CONFIG_YAFFS_RAM_ENABLED
 #include "yaffs_nandemul.h" 
@@ -182,6 +182,10 @@
 	mmap:		generic_file_mmap,
 	flush:		yaffs_file_flush,
 	fsync:		yaffs_sync_object,
+	
+#if (LINUX_VERSION_CODE > KERNEL_VERSION(2,5,0))
+	sendfile:	generic_file_sendfile,
+#endif
 };
 
 
@@ -231,14 +235,14 @@
 
 static void yaffs_GrossLock(yaffs_Device *dev)
 {
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs locking\n"));
+	T(YAFFS_TRACE_OS,("yaffs locking\n"));
 
 	down(&dev->grossLock);
 }
 
 static void yaffs_GrossUnlock(yaffs_Device *dev)
 {
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs unlocking\n"));
+	T(YAFFS_TRACE_OS,("yaffs unlocking\n"));
 	up(&dev->grossLock);
 
 }
@@ -309,7 +313,7 @@
 	yaffs_GrossLock(dev);
 
 	
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_lookup for %d:%s\n",yaffs_InodeToObject(dir)->objectId,dentry->d_name.name));
+	T(YAFFS_TRACE_OS,("yaffs_lookup for %d:%s\n",yaffs_InodeToObject(dir)->objectId,dentry->d_name.name));
 	
 	obj = yaffs_FindObjectByName(yaffs_InodeToObject(dir),dentry->d_name.name);
 	
@@ -319,13 +323,13 @@
 	
 	if(obj)
 	{
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_lookup found %d\n",obj->objectId));
+		T(YAFFS_TRACE_OS,("yaffs_lookup found %d\n",obj->objectId));
 		
 		inode = yaffs_get_inode(dir->i_sb, obj->st_mode,0,obj);
 		
 		if(inode)
 		{
-			T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_loookup dentry \n"));
+			T(YAFFS_TRACE_OS,("yaffs_loookup dentry \n"));
 /* #if 0 asserted by NCB for 2.5/6 compatability - falls through to d_add even if NULL inode */	
 #if 0
 			//dget(dentry); // try to solve directory bug
@@ -341,7 +345,7 @@
 	}
 	else
 	{
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_lookup not found\n"));
+		T(YAFFS_TRACE_OS,("yaffs_lookup not found\n"));
 		
 	}
 	yaffs_GrossUnlock(dev);
@@ -358,7 +362,8 @@
 // Put inode is called when the inode **structure** is put.
 static void yaffs_put_inode(struct inode *inode)
 {
-	T(YAFFS_TRACE_OS,("yaffs_put_inode: ino %d, count %d\n",(int)inode->i_ino, atomic_read(&inode->i_count)));
+	T(YAFFS_TRACE_OS,("yaffs_put_inode: ino %d, count %d nlink %d\n",
+	                       (int)inode->i_ino, atomic_read(&inode->i_count), inode->i_nlink));
 	
 }
 
@@ -422,7 +427,7 @@
 	
 	yaffs_Device *dev = obj->myDev;
 	
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_file_flush object %d (%s)\n",obj->objectId,
+	T(YAFFS_TRACE_OS,("yaffs_file_flush object %d (%s)\n",obj->objectId,
 				obj->dirty ? "dirty" : "clean"));
 
 	yaffs_GrossLock(dev);
@@ -446,7 +451,7 @@
 
 	yaffs_Device *dev;
 
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_readpage at %08x, size %08x\n",
+	T(YAFFS_TRACE_OS,("yaffs_readpage at %08x, size %08x\n",
 	              (unsigned)(pg->index << PAGE_CACHE_SHIFT), (unsigned)PAGE_CACHE_SIZE));
 
 	obj  = yaffs_DentryToObject(f->f_dentry);
@@ -480,7 +485,7 @@
 	kunmap(pg);
 
 
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_readpage done\n"));
+	T(YAFFS_TRACE_OS,("yaffs_readpage done\n"));
 	return ret;
 }
 
@@ -557,7 +562,7 @@
 static int yaffs_prepare_write(struct file *f, struct page *pg, unsigned offset, unsigned to)
 {
 
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_prepair_write\n"));
+	T(YAFFS_TRACE_OS,("yaffs_prepair_write\n"));
 	if(!Page_Uptodate(pg) && (offset || to < PAGE_CACHE_SIZE))
 		return  yaffs_readpage_nolock(f,pg);    
 
@@ -576,13 +581,13 @@
 	unsigned spos = pos;
 	unsigned saddr = (unsigned)addr;
 
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_commit_write addr %x pos %x nBytes %d\n",saddr,spos,nBytes));
+	T(YAFFS_TRACE_OS,("yaffs_commit_write addr %x pos %x nBytes %d\n",saddr,spos,nBytes));
 	
 	nWritten = yaffs_file_write(f,addr, nBytes, &pos);
 	
 	if(nWritten != nBytes)
 	{
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_commit_write not same size nWritten %d  nBytes %d\n",nWritten,nBytes));
+		T(YAFFS_TRACE_OS,("yaffs_commit_write not same size nWritten %d  nBytes %d\n",nWritten,nBytes));
 		SetPageError(pg);
 		ClearPageUptodate(pg);
 	}
@@ -591,7 +596,7 @@
 		SetPageUptodate(pg);
 	}
 
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_commit_write returning %d\n",nWritten));
+	T(YAFFS_TRACE_OS,("yaffs_commit_write returning %d\n",nWritten));
 	
 	return nWritten;
 
@@ -629,7 +634,7 @@
 
 		inode->i_nlink = yaffs_GetObjectLinkCount(obj);
 		
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_FillInode mode %x uid %d gid %d size %d count %d\n",
+		T(YAFFS_TRACE_OS,("yaffs_FillInode mode %x uid %d gid %d size %d count %d\n",
 				inode->i_mode, inode->i_uid, inode->i_gid, (int)inode->i_size, atomic_read(&inode->i_count)));
 		
 		switch (obj->st_mode & S_IFMT) 
@@ -658,7 +663,7 @@
 	}
 	else
 	{
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_FileInode invalid parameters\n"));
+		T(YAFFS_TRACE_OS,("yaffs_FileInode invalid parameters\n"));
 	}
 
 }
@@ -667,7 +672,7 @@
 {
 	struct inode * inode;
 	
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_get_inode for object %d\n",obj->objectId));
+	T(YAFFS_TRACE_OS,("yaffs_get_inode for object %d\n",obj->objectId));
 
 	inode = iget(sb,obj->objectId);
 
@@ -684,7 +689,7 @@
 	struct inode *inode;
 	yaffs_Device *dev;
 	
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_file_read\n"));
+	T(YAFFS_TRACE_OS,("yaffs_file_read\n"));
 
 	obj  = yaffs_DentryToObject(f->f_dentry);
 	
@@ -716,7 +721,7 @@
 	
 	ipos = *pos;
 	
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_file_read read %d bytes, %d read at %d\n",n,nRead,ipos));
+	T(YAFFS_TRACE_OS,("yaffs_file_read read %d bytes, %d read at %d\n",n,nRead,ipos));
 	return nRead;
 	
 }
@@ -750,16 +755,16 @@
 	
 	if(!obj)
 	{
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_file_write: hey obj is null!\n"));
+		T(YAFFS_TRACE_OS,("yaffs_file_write: hey obj is null!\n"));
 	}
 	else
 	{
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_file_write about to write writing %d bytes to object %d at %d\n",n,obj->objectId,ipos));
+		T(YAFFS_TRACE_OS,("yaffs_file_write about to write writing %d bytes to object %d at %d\n",n,obj->objectId,ipos));
 	}
 
 	nWritten = yaffs_WriteDataToFile(obj,buf,ipos,n);
 
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_file_write writing %d bytes, %d written at %d\n",n,nWritten,ipos));
+	T(YAFFS_TRACE_OS,("yaffs_file_write writing %d bytes, %d written at %d\n",n,nWritten,ipos));
 	if(nWritten > 0)
 	{
 		ipos += nWritten;
@@ -769,7 +774,7 @@
 			inode->i_size = ipos;
 			inode->i_blocks = (ipos + 511)>>9;
 			
-			T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_file_write size updated to %d bytes, %d blocks\n",ipos,(int)(inode->i_blocks)));
+			T(YAFFS_TRACE_OS,("yaffs_file_write size updated to %d bytes, %d blocks\n",ipos,(int)(inode->i_blocks)));
 		}
 		
 	}
@@ -801,7 +806,7 @@
 	
 	if(offset == 0)
 	{
-        T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_readdir: entry . ino %d \n",(int)inode->i_ino));
+        T(YAFFS_TRACE_OS,("yaffs_readdir: entry . ino %d \n",(int)inode->i_ino));
 		if(filldir(dirent,".",1,offset,inode->i_ino,DT_DIR) < 0)
 		{
 			goto out;
@@ -811,7 +816,7 @@
 	}
 	if(offset == 1)
 	{
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_readdir: entry .. ino %d \n",(int)f->f_dentry->d_parent->d_inode->i_ino));
+		T(YAFFS_TRACE_OS,("yaffs_readdir: entry .. ino %d \n",(int)f->f_dentry->d_parent->d_inode->i_ino));
 		if(filldir(dirent,"..",2,offset,f->f_dentry->d_parent->d_inode->i_ino,DT_DIR) < 0)
 		{
 			goto out;
@@ -830,7 +835,7 @@
 			l = list_entry(i, yaffs_Object,siblings);
 			
 			yaffs_GetObjectName(l,name,YAFFS_MAX_NAME_LENGTH+1); 
-			T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_readdir: %s inode %d\n",name,yaffs_GetObjectInode(l)));
+			T(YAFFS_TRACE_OS,("yaffs_readdir: %s inode %d\n",name,yaffs_GetObjectInode(l)));
 			
 			if(filldir(dirent,
 					   name,
@@ -878,12 +883,12 @@
 
 	if(parent)
 	{
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_mknod: parent object %d type %d\n",
+		T(YAFFS_TRACE_OS,("yaffs_mknod: parent object %d type %d\n",
 					 parent->objectId,parent->variantType));
 	}
 	else
 	{
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_mknod: could not get parent object\n"));
+		T(YAFFS_TRACE_OS,("yaffs_mknod: could not get parent object\n"));
 		return -EPERM;
 	}
 	
@@ -898,19 +903,19 @@
 	{
 		default:
 			// Special (socket, fifo, device...)
-			T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_mknod: making special\n"));
+			T(YAFFS_TRACE_OS,("yaffs_mknod: making special\n"));
 			obj = yaffs_MknodSpecial(parent,dentry->d_name.name,mode,current->uid, current->gid,rdev);
 			break;
 		case S_IFREG:	// file		
-			T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_mknod: making file\n"));
+			T(YAFFS_TRACE_OS,("yaffs_mknod: making file\n"));
 			obj = yaffs_MknodFile(parent,dentry->d_name.name,mode,current->uid, current->gid);
 			break;
 		case S_IFDIR:	// directory
-			T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_mknod: making directory\n"));
+			T(YAFFS_TRACE_OS,("yaffs_mknod: making directory\n"));
 			obj = yaffs_MknodDirectory(parent,dentry->d_name.name,mode,current->uid, current->gid);
 			break;
 		case S_IFLNK:	// symlink
-			T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_mknod: making file\n"));
+			T(YAFFS_TRACE_OS,("yaffs_mknod: making file\n"));
 			obj = NULL; // Do we ever get here?
 			break;
 	}
@@ -919,12 +924,12 @@
 	{
 		inode = yaffs_get_inode(dir->i_sb, mode, rdev, obj);
 		d_instantiate(dentry, inode);
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_mknod created object %d count = %d\n",obj->objectId,atomic_read(&inode->i_count)));
+		T(YAFFS_TRACE_OS,("yaffs_mknod created object %d count = %d\n",obj->objectId,atomic_read(&inode->i_count)));
 		error = 0;
 	}
 	else
 	{
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_mknod failed making object\n"));
+		T(YAFFS_TRACE_OS,("yaffs_mknod failed making object\n"));
 		error = -ENOMEM;
 	}
 
@@ -936,7 +941,7 @@
 static int yaffs_mkdir(struct inode * dir, struct dentry * dentry, int mode)
 {
 	int retVal;
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_mkdir\n"));
+	T(YAFFS_TRACE_OS,("yaffs_mkdir\n"));
 	retVal =  yaffs_mknod(dir, dentry, mode | S_IFDIR, 0);
 #if 0
  // attempt to fix dir bug - didn't work
@@ -955,7 +960,7 @@
 static int yaffs_create(struct inode *dir, struct dentry *dentry, int mode)
 #endif
 {
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_create\n"));
+	T(YAFFS_TRACE_OS,("yaffs_create\n"));
 	return yaffs_mknod(dir, dentry, mode | S_IFREG, 0);
 }
 
@@ -967,7 +972,7 @@
 	yaffs_Device *dev;
 	
 	
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_unlink %d:%s\n",(int)(dir->i_ino),dentry->d_name.name));
+	T(YAFFS_TRACE_OS,("yaffs_unlink %d:%s\n",(int)(dir->i_ino),dentry->d_name.name));
 	
 	dev = yaffs_InodeToObject(dir)->myDev;
 	
@@ -1002,7 +1007,7 @@
 	yaffs_Object *link=NULL;
 	yaffs_Device *dev;
 	
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_link\n"));
+	T(YAFFS_TRACE_OS,("yaffs_link\n"));
 	
 	obj = yaffs_InodeToObject(inode);
 	dev = obj->myDev;
@@ -1020,7 +1025,7 @@
 		old_dentry->d_inode->i_nlink =  yaffs_GetObjectLinkCount(obj);
 		d_instantiate(dentry, old_dentry->d_inode);
 		atomic_inc(&old_dentry->d_inode->i_count);
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_link link count %d i_count %d\n",	
+		T(YAFFS_TRACE_OS,("yaffs_link link count %d i_count %d\n",	
 			old_dentry->d_inode->i_nlink,atomic_read(&old_dentry->d_inode->i_count)));
 	
 	}
@@ -1044,7 +1049,7 @@
 	yaffs_Object *obj;
 	yaffs_Device *dev;
 	
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_symlink\n"));
+	T(YAFFS_TRACE_OS,("yaffs_symlink\n"));
 	
 	dev = yaffs_InodeToObject(dir)->myDev;
 	yaffs_GrossLock(dev);
@@ -1060,12 +1065,12 @@
 	
 		inode = yaffs_get_inode(dir->i_sb, obj->st_mode, 0, obj);
 		d_instantiate(dentry, inode);
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"symlink created OK\n"));
+		T(YAFFS_TRACE_OS,("symlink created OK\n"));
 		return 0;
 	}
 	else
 	{
-		T(YAFFS_TRACE_OS,(KERN_DEBUG"symlink not created\n"));
+		T(YAFFS_TRACE_OS,("symlink not created\n"));
 
 	}
 	
@@ -1082,7 +1087,7 @@
 
 	dev = obj->myDev;
 	
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_sync_object\n"));
+	T(YAFFS_TRACE_OS,("yaffs_sync_object\n"));
 	yaffs_GrossLock(dev);
 	yaffs_FlushFile(obj,1);
 	yaffs_GrossUnlock(dev);
@@ -1151,7 +1156,7 @@
 	int error;
 	yaffs_Device *dev;
 	
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_setattr of object %d\n",yaffs_InodeToObject(inode)->objectId));
+	T(YAFFS_TRACE_OS,("yaffs_setattr of object %d\n",yaffs_InodeToObject(inode)->objectId));
 	
 	if((error = inode_change_ok(inode,attr)) == 0)
 	{
@@ -1180,7 +1185,7 @@
 #endif
 {
 	yaffs_Device *dev = yaffs_SuperToDevice(sb);
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_statfs\n"));
+	T(YAFFS_TRACE_OS,("yaffs_statfs\n"));
 
 	yaffs_GrossLock(dev);
 	
@@ -1207,7 +1212,7 @@
 	yaffs_Object *obj ; 
 	yaffs_Device *dev = yaffs_SuperToDevice(inode->i_sb);
 	
-	T(YAFFS_TRACE_OS,(KERN_DEBUG"yaffs_read_inode for %d\n",(int)inode->i_ino));
+	T(YAFFS_TRACE_OS,("yaffs_read_inode for %d\n",(int)inode->i_ino));
 
 	obj  = yaffs_FindObjectByNumber(dev,inode->i_ino);
 	
@@ -1268,16 +1273,17 @@
 	
 	sb->s_magic = YAFFS_MAGIC;
 	sb->s_op = &yaffs_super_ops;
-	
+
+	/*	
 	if(!sb)
-		printk(KERN_INFO"yaffs: sb is NULL\n");
+		T(YAFFS_TRACE_OS,("yaffs: sb is NULL\n"));
 	else if(!sb->s_dev)
-		printk(KERN_INFO"yaffs: sb->s_dev is NULL\n");
+		T(YAFFS_TRACE_OS,("yaffs: sb->s_dev is NULL\n"));
 	else if(! kdevname(sb->s_dev))
-		printk(KERN_INFO"yaffs: kdevname is NULL\n");
+		T(YAFFS_TRACE_OS,("yaffs: kdevname is NULL\n"));
 	else
-		printk(KERN_INFO"yaffs: dev is %d name is \"%s\"\n", sb->s_dev, kdevname(sb->s_dev));
-
+		T(YAFFS_TRACE_OS,("yaffs: dev is %d name is \"%s\"\n", sb->s_dev, kdevname(sb->s_dev)));
+	*/
 	
 
 #ifdef CONFIG_YAFFS_USE_CHUNK_SIZE
@@ -1305,7 +1311,7 @@
 		if(!dev)
 		{
 			// Deep shit could not allocate device structure
-			printk(KERN_DEBUG"yaffs_read_super: Failed trying to allocate yaffs_Device. Terminating debug.\n");
+			T(YAFFS_TRACE_OS,("yaffs_read_super: Failed trying to allocate yaffs_Device. Terminating debug.\n"));
 			return NULL;
 		}
 
@@ -1334,8 +1340,8 @@
 #ifdef CONFIG_YAFFS_MTD_ENABLED
 		struct mtd_info *mtd;
 		
-		printk(KERN_DEBUG "yaffs: Attempting MTD mount on %u.%u, \"%s\"\n",
-		 MAJOR(sb->s_dev),MINOR(sb->s_dev),kdevname(sb->s_dev));
+		T(YAFFS_TRACE_ALWAYS,( "yaffs: Attempting MTD mount on %u.%u, \"%s\"\n",
+		 MAJOR(sb->s_dev),MINOR(sb->s_dev),kdevname(sb->s_dev)));
 			
 		// Check it's an mtd device.....
 		if(MAJOR(sb->s_dev) != MTD_BLOCK_MAJOR)
@@ -1347,24 +1353,24 @@
 		mtd = get_mtd_device(NULL, MINOR(sb->s_dev));
 		if (!mtd) 
 		{
-			printk(KERN_DEBUG "yaffs: MTD device #%u doesn't appear to exist\n", MINOR(sb->s_dev));
+			T(YAFFS_TRACE_ALWAYS,( "yaffs: MTD device #%u doesn't appear to exist\n", MINOR(sb->s_dev)));
 			return NULL;
 		}
 		
 		// Check it's NAND
 		if(mtd->type != MTD_NANDFLASH)
 		{
-			printk(KERN_DEBUG "yaffs: MTD device is not NAND it's type %d\n", mtd->type);
+			T(YAFFS_TRACE_ALWAYS,( "yaffs: MTD device is not NAND it's type %d\n", mtd->type));
 			return NULL;
 		}
 
-		//printk(KERN_DEBUG" erase %x\n",mtd->erase);
-		//printk(KERN_DEBUG" read %x\n",mtd->read);
-		//printk(KERN_DEBUG" write %x\n",mtd->write);
-		//printk(KERN_DEBUG" readoob %x\n",mtd->read_oob);
-		//printk(KERN_DEBUG" writeoob %x\n",mtd->write_oob);
-		//printk(KERN_DEBUG" oobblock %x\n",mtd->oobblock);
-		//printk(KERN_DEBUG" oobsize %x\n",mtd->oobsize);
+		//T(YAFFS_TRACE_OS,(KERN_DEBUG" erase %x\n",mtd->erase);
+		//T(YAFFS_TRACE_OS,(KERN_DEBUG" read %x\n",mtd->read);
+		//T(YAFFS_TRACE_OS,(KERN_DEBUG" write %x\n",mtd->write);
+		//T(YAFFS_TRACE_OS,(KERN_DEBUG" readoob %x\n",mtd->read_oob);
+		//T(YAFFS_TRACE_OS,(KERN_DEBUG" writeoob %x\n",mtd->write_oob);
+		//T(YAFFS_TRACE_OS,(KERN_DEBUG" oobblock %x\n",mtd->oobblock);
+		//T(YAFFS_TRACE_OS,(KERN_DEBUG" oobsize %x\n",mtd->oobsize);
 
 
 		if(!mtd->erase ||
@@ -1377,14 +1383,14 @@
 		   !mtd->read_oob ||
 		   !mtd->write_oob )
 		{
-			printk(KERN_DEBUG "yaffs: MTD device does not support required functions\n");
+			T(YAFFS_TRACE_ALWAYS,( "yaffs: MTD device does not support required functions\n"));
 			return NULL;
 		}
 		
 		if(mtd->oobblock != YAFFS_BYTES_PER_CHUNK ||
 		   mtd->oobsize != YAFFS_BYTES_PER_SPARE)
 		{
-			printk(KERN_DEBUG "yaffs: MTD device does not support have the right page sizes\n");
+			T(YAFFS_TRACE_ALWAYS,( "yaffs: MTD device does not support have the right page sizes\n"));
 			return NULL;
 		}
 		   
@@ -1402,7 +1408,7 @@
 		if(!dev)
 		{
 			// Deep shit could not allocate device structure
-			printk(KERN_DEBUG"yaffs_read_super: Failed trying to allocate yaffs_Device. Terminating debug.\n");
+			T(YAFFS_TRACE_ALWAYS,("yaffs_read_super: Failed trying to allocate yaffs_Device. Terminating debug.\n"));
 			return NULL;
 		}
 
@@ -1417,7 +1423,7 @@
 		dev->nChunksPerBlock = YAFFS_CHUNKS_PER_BLOCK;
 		dev->nBytesPerChunk = YAFFS_BYTES_PER_CHUNK;
 		dev->nReservedBlocks = 5;
-		dev->nShortOpCaches = 10; // Enable short op caching
+		dev->nShortOpCaches = 0; // Enable short op caching
 		
 
 		// ... and the functions.
@@ -1499,8 +1505,8 @@
 	.owner		= THIS_MODULE,
 	.name		= "yaffs",
 	.get_sb		= yaffs_read_super,
-//	.kill_sb	= kill_block_super,
-	.kill_sb	= kill_litter_super,
+	.kill_sb	= kill_block_super,
+//	.kill_sb	= kill_litter_super,
 	.fs_flags	= FS_REQUIRES_DEV,
 };
 #else
@@ -1529,8 +1535,8 @@
 	.owner		= THIS_MODULE,
 	.name		= "yaffsram",
 	.get_sb		= yaffs_ram_read_super,
-//	.kill_sb	= kill_block_super,
-	.kill_sb	= kill_litter_super,
+	.kill_sb	= kill_block_super,
+//	.kill_sb	= kill_litter_super,
 	.fs_flags	= FS_SINGLE,
 };
 #else
@@ -1620,7 +1626,7 @@
 	)
 {
 
-	printk(KERN_DEBUG "yaffs write size %d\n",count);
+	T(YAFFS_TRACE_OS,( "yaffs write size %d\n",count));
 	return count;
 }
 
@@ -1630,11 +1636,11 @@
 	
 	yaffs_dev = yaffsram_dev = NULL;
 	
-	printk(KERN_DEBUG "yaffs " __DATE__ " " __TIME__ " Initialisation\n");
+	T(YAFFS_TRACE_OS,( "yaffs " __DATE__ " " __TIME__ " Initialisation\n"));
 #ifdef CONFIG_YAFFS_USE_GENERIC_RW
-	printk(KERN_DEBUG "yaffs is using generic read/write (caching)\n");
+	T(YAFFS_TRACE_OS,( "yaffs is using generic read/write (caching)\n"));
 #else
-	printk(KERN_DEBUG "yaffs is using direct read/write (uncached)\n");
+	T(YAFFS_TRACE_OS,( "yaffs is using direct read/write (uncached)\n"));
 #endif
 
 
@@ -1687,7 +1693,7 @@
 
 static void __exit exit_yaffs_fs(void)
 {
-	printk(KERN_DEBUG "yaffs " __DATE__ " " __TIME__ " Clean up\n");
+	T(YAFFS_TRACE_OS,( "yaffs " __DATE__ " " __TIME__ " Clean up\n"));
 
     remove_proc_entry("yaffs",&proc_root);
     
Index: fs/yaffs/yaffs_guts.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/fs/yaffs/yaffs_guts.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- fs/yaffs/yaffs_guts.c	16 Nov 2004 17:16:24 -0000	1.1
+++ fs/yaffs/yaffs_guts.c	10 Jan 2005 18:27:13 -0000	1.2
@@ -14,7 +14,7 @@
  */
  //yaffs_guts.c
 
-const char *yaffs_guts_c_version="$Id: yaffs_guts.c,v 1.1 2004/11/16 17:16:24 joff Exp $";
+const char *yaffs_guts_c_version="$Id: yaffs_guts.c,v 1.2 2005/01/10 18:27:13 eddie Exp $";
 
 #include "yportenv.h"
 
@@ -1623,6 +1623,11 @@
 			in = list_entry(i, yaffs_Object,hashLink);
 			if(in->objectId == number)
 			{
+#ifdef __KERNEL__
+				// Don't tell the VFS about this if it has been marked for freeing
+ 				if(in->deferedFree) 
+				    return NULL;
+#endif
 				return in;
 			}
 		}
@@ -3136,7 +3141,7 @@
 	int lowest;
 	int i;
 	yaffs_ChunkCache *cache;
-	int chunkWritten;
+	int chunkWritten = 0;
 	int nBytes;
 	int nCaches = obj->myDev->nShortOpCaches;
 	
@@ -3765,6 +3770,7 @@
 	
 	yaffs_RemoveObjectFromDirectory(in);
 	yaffs_DeleteChunk(in->myDev,in->chunkId,1);
+	in->chunkId = -1;
 #if 0
 #ifdef __KERNEL__
 	if(in->myInode)
